c
c**********************************************************************************
c
C         A GENERAL BACKGROUND FUNCTION - SO THAT NEW FUNCTIONS CAN BE ADDED      
      FUNCTION BACKFN(JDS,BTYPE,TOF,THETA,IBCK,ERROR)
      INCLUDE 'param.inc'
      INTEGER JDS,BTYPE, J, JP, BO, IBCK,NBT,ERROR
      LOGICAL TOF     
C         JDS = HISTOGRAM #, BTYPE = BACKGROUND TYPE
      REAL THETA,BV(24),BK,QR,QT,LAMDA,SLOPE,DIFF,PI,DENOM
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS)
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
C                                                  
      ERROR = 0
      NBT = 6*(IBCK+1)
      BK=0.0                                                              
      PI = 3.14159265359
      JP = 1 + (JDS-1)*MAXIGL
      IF(THETA.LT.0.1) GO TO 30
C     
      IF (BTYPE.EQ.0) THEN                                          
		DO 100 J=1,NBT-1                                                        !NORMAL POLYNOMIAL
  100		BV(J) = THETA**(J-1)                                    
          BV(NBT) = 1/THETA
          DO 20 J=1,NBT
   20     BK=BK+GLB(J+JP)*BV(J)                                        
      ENDIF
      IF ((BTYPE.LE.-2).AND.(BTYPE.GE.-5)) THEN														!OTHER POLYNOMIAL
          BO = ABS(BTYPE)-1
          CALL CHEB(BO,THETA,BV,NBT)
          DO 21 J=1,NBT
   21     BK=BK+GLB(J+JP)*BV(J)                                       
      ENDIF
      IF (BTYPE.EQ.-1) THEN														!AMORPHOUS SINC FUNCTION
		IF (TOF) THEN
              QT = 2*PI/DVAL(THETA,LAMDA(JDS,1),LAMDA(JDS,2),GLB(1+JP))        
          ELSE
              QT = 4*PI*SIN(THETA*0.008726646259972)/LAMDA(JDS,1)
          ENDIF
          DO 120 J=1,2+IBCK*3
              QR = QT*GLB(JP+2*J+2)
			IF (QR.LE.0) THEN
				ERROR = 60
			ELSE
   				BK=BK+GLB(JP+2*J+1)*SIN(QR)/QR
			ENDIF
  120     CONTINUE
          BK = BK + GLB(JP+1) + GLB(2+JP)*THETA 
      ENDIF
      IF (BTYPE.EQ.-6) THEN                                                       !DAMPED AMORPHOUS SINC FUNCTION
		IF (TOF) THEN
              QT = 2*PI/DVAL(THETA,LAMDA(JDS,1),LAMDA(JDS,2),GLB(1+JP))        
          ELSE
              QT =  4*PI*SIN(THETA*0.008726646259972)/LAMDA(JDS,1)
          ENDIF
          DO 220 J=1,1+IBCK*2
              QR = QT*GLB(JP+3*J+2)
			IF (QR.LE.0) THEN
				ERROR = 60
			ELSE
              BK=BK+GLB(JP+3*J+1)*SIN(QR)*EXP(-GLB(JP+3*J+3)*QT*QT)/QR
			ENDIF
  220     CONTINUE
          BK = BK + GLB(JP+1) + GLB(2+JP)*THETA + GLB(3+JP)*THETA*THETA
c          write(*,*) theta, j,BK,EXP(-GLB(JP+3*1+3)*QT*QT) 
      ENDIF
      IF (BTYPE.GT.1) THEN                                                        !(LINEARLY) INTERPOLATED
          IF (THETA.LE.POS(JDS,1)) THEN
              BK = BCK(JDS,1)
              GOTO 30
          ENDIF
          IF (THETA.GE.POS(JDS,NBCKGD(JDS))) THEN
              BK = BCK(JDS,NBCKGD(JDS))
              GOTO 30
          ENDIF
          DO 130 I=2,NBCKGD(JDS)
              IF ((THETA.LE.POS(JDS,I)).AND.(THETA.GT.POS(JDS,I-1)))THEN
                  DIFF = (POS(JDS,I) - THETA)
                  DENOM = POS(JDS,I)-POS(JDS,I-1)
				IF (DENOM.EQ.0) THEN
					ERROR = 61
					SLOPE = 0.0
				ELSE
					SLOPE = (BCK(JDS,I)-BCK(JDS,I-1))/DENOM
                  ENDIF
				BK = BCK(JDS,I) - DIFF*SLOPE
                  GOTO 30
              ENDIF
  130     CONTINUE
      ENDIF
   30 IF (TOF) THEN
          BACKFN = BK*FINSPEC(JDS,THETA)                                                     !*FINSPEC(THETA)
      ELSE
          BACKFN = BK
      ENDIF
      RETURN
      END           
c
c**********************************************************************************
c
c             SUBROUTINE TO RETURN THE DERIVATIVES OF THE BACKGROUND FUNCTIONS
      SUBROUTINE BACKDER(JDS,BTYPE,THETA,TOF,BDERIV,IBCK,ERROR)
      INCLUDE 'param.inc'
      INTEGER JDS,BTYPE, J, JP, BO, IBCK, NBT, ERROR     
      REAL THETA,BDERIV(24),QT,QR,LAMDA,PI
      LOGICAL TOF
C
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),
     &  IABSCOR(MAXDS)
C
      ERROR = 0
      PI =  3.14159265359
      JP = (JDS-1)*MAXIGL                    
      NBT = 6*(IBCK+1)
      DO 10 J=1,NBT
   10      BDERIV(J) = 0.0
C         AMORPHOUS SINC DERIVATIVES      
      IF (BTYPE.EQ.-1) THEN
          IF (TOF) THEN
              QT = 2*PI/DVAL(THETA,LAMDA(JDS,1),LAMDA(JDS,2),GLB(1+JP))
          ELSE
              QT =  4*PI*SIN(THETA*0.008726646259972)/LAMDA(JDS,1)
          ENDIF
          BDERIV(1) = 1.0                                                      
          BDERIV(2) = THETA                                                      
          DO 20 I=4,NBT+1                    
              JJ = I+JP
              IF(MOD(I,2).EQ.0) THEN                                              !AMP
                  QR = QT*GLB(JJ+1) 
                  IF(QR.NE.0) THEN
					BDERIV(I-1)=SIN(QR)/QR
				ELSE
					ERROR = 62
				ENDIF
              ELSE                                                                !R
                  QR = QT*GLB(JJ) 
                  IF(QR.NE.0) THEN
					BDERIV(I-1)=GLB(JJ-1)/GLB(JJ)*(COS(QR)-SIN(QR)/QR)
				ELSE
					ERROR = 62
				ENDIF
              ENDIF
   20     CONTINUE
      ENDIF                  
C         DAMPED AMORPHOUS SINC DERIVATIVES      
      IF (BTYPE.EQ.-6) THEN
          IF (TOF) THEN
              QT = 2*PI/DVAL(THETA,LAMDA(JDS,1),LAMDA(JDS,2),GLB(1+JP))
          ELSE
              QT =  4*PI*SIN(THETA*0.008726646259972)/LAMDA(JDS,1)
          ENDIF
          BDERIV(1) = 1.0                                                      
          BDERIV(2) = THETA                                                      
          BDERIV(3) = THETA*THETA                                                      
         DO 200 I=5,NBT+1                    
              JJ = I+JP
              IF(MOD(I-5,3).EQ.0) THEN                                             !AMP
                  QR = QT*GLB(JJ+1) 
                  IF(QR.NE.0) THEN
                      BDERIV(I-1)=SIN(QR)*EXP(-GLB(JJ+2)*QT*QT)/QR
                  ELSE
                  	ERROR = 62
                  ENDIF
              ENDIF
              IF(MOD(I-5,3).EQ.1) THEN                                             !R
                  QR = QT*GLB(JJ) 
                  IF(QR.NE.0) THEN
                      BDERIV(I-1)=GLB(JJ-1)/GLB(JJ)*(COS(QR)-SIN(QR)/QR)
	*                            *EXP(-GLB(JJ+1)*QT*QT)
                  ELSE
                      ERROR = 62
				ENDIF
              ENDIF
              IF(MOD(I-5,3).EQ.2) THEN                                             !DAMP
                  QR = QT*GLB(JJ-1) 
                  IF(QR.NE.0) THEN
                      BDERIV(I-1)=-GLB(JJ-2)*QT*QT*SIN(QR)/QR*
     *                            EXP(-GLB(JJ)*QT*QT)/QR
				ELSE
                      ERROR = 62
				ENDIF
              ENDIF
  200     CONTINUE
      ENDIF                  
C         NORMAL POLYNOMIAL DERVIATIVES
      IF (BTYPE.EQ.0) THEN
          DO 30 I=1,NBT-1
              IF(I.EQ.1.AND.THETA.EQ.0.0) THETA=1.0
   30         BDERIV(I)=THETA**(I-1)                                           
          BDERIV(NBT)=1.0/THETA
      ENDIF
C         CHEBY DERIVERATIVES
      IF ((BTYPE.LE.-2).AND.(BTYPE.GE.-5)) THEN                                                  
          BO = ABS(BTYPE)-1
          CALL CHEB(BO,THETA,BDERIV,NBT)
      ENDIF
c
      IF (TOF) THEN
          DO 50 I =1,NBT
   50         BDERIV(I) = BDERIV(I)*FINSPEC(JDS,THETA)
      ENDIF
C
      RETURN
      END                             
c
c**********************************************************************************
c
C           CALCULATE CHEB COEFF FOR CHEB I,CHEB II, AND SHIFTED EQUIV.'S
c
      SUBROUTINE CHEB(CTYPE,X,CA,NBT)      
      INTEGER CTYPE,I
      REAL X,CA(24)
      REAL AN(4),BN(4),T1(4)      
      DATA AN/2.0,4.0,2.0,4.0/,BN/0.0,-2.0,0.0,-2.0/
      DATA T1/1.0,2.0,1.0,2.0/                                          !PARAMETERS FOR CHEBY I&II 
      CA(1) = 1.0                                                       ! and SHIFTED CHEB I&II
      CA(2) = T1(CTYPE)*X
      DO 10 I=3,NBT
          CA(I) = (AN(CTYPE)*X + BN(CTYPE))*CA(I-1) - CA(I-2)
   10 CONTINUE
      RETURN
      END              
c
c**********************************************************************************
c
C         File Background - not as fancy or as complicated as DATAREAD
C      
      SUBROUTINE READBCK(K,NFMT,LSYNC,THMIN,STEP,THMAX,ERROR)
      include 'param.inc'
      REAL BKMIN,BKSTEP,BKMAX
      INTEGER NP,NSKIP,ERROR
      CHARACTER FNAME*64, BCKTITLE*80,FTEMP*64
      COMMON/FILEINT/LC,FNAME,FTEMP
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
C                     
      ERROR = 0
C
  100 FORMAT(3F8.3)
      IF (NFMT.LE.3) THEN
          IF (LSYNC.EQ.0) READ(2,100,ERR=11) BKMIN,BKSTEP,BKMAX
          IF (LSYNC.EQ.1) READ(2,*,ERR=11) BKMIN,BKSTEP,BKMAX
          IF (BKMIN.GT.THMIN) ERROR = 27
          IF (BKSTEP.NE.STEP) ERROR = 28
          IF (BKMAX.LT.THMAX) ERROR = 29   
          IF (ERROR.NE.0) GOTO 20
          NP = (BKMAX-BKMIN)/BKSTEP + 1.5
          IF (NFMT.EQ.0) READ(2,200,ERR=12)(BK(K,I),I=1,NP)
          IF (NFMT.EQ.1) READ(2,210,ERR=12)(BK(K,I),I=1,NP)
          IF (NFMT.EQ.2) READ(2,220,ERR=12)(BK(K,I),I=1,NP)
      ELSE
          READ(2,'(A80)') BCKTITLE
          I = 1
          OLDANG = 0.0
   10     READ(2,*,ERR=35,END=30) ANGLE,BCOUNT
          IF (ANGLE.LT.THMIN) GOTO 10                                     !SKIP READING UNTIL ANGLE = THMIN
          IF (ANGLE.EQ.-1.0) GOTO 30
          OLDANG = ANGLE
          IF (I.EQ.1) BKMIN = ANGLE
          IF (ANGLE.GT.THMAX) GOTO 30
          BK(K,I) = BCOUNT
          I = I + 1                            
          GOTO 10  
C
   35     BACKSPACE(2)                                                   !if errored then we have hit the next title
   30     BKMAX = OLDANG
          NP = I-1
          BKSTEP = (BKMAX - BKMIN)/(NP-1)
          IF (BKMIN.NE.THMIN) ERROR = 27
          IF (BKSTEP.NE.STEP) ERROR = 28
          IF (BKMAX.NE.THMAX) ERROR = 29
          IF (ERROR.NE.0) GOTO 20
      ENDIF
  200 FORMAT(10(2X,F6.0))
  210 FORMAT(10(1X,F7.0))
  220 FORMAT(10F8.0)
      IF (BKMIN.LT.THMIN) THEN
          NSKIP = (THMIN-BKMIN)/BKSTEP
          DO 300 I=1,NP-NSKIP
  300         BK(K,I)=BK(K,I+NSKIP)
      ENDIF
      RETURN
C
   13 ERROR = 24
      GOTO 20
   11 ERROR = 25
      GOTO 20
   12 ERROR = 26
   20 CONTINUE
      IF (ERROR.EQ.24) WRITE(7,*) 'BACKGROUND FILE NOT FOUND'
      IF (ERROR.EQ.25) WRITE(7,*) 'ERROR READING START/STEP/STOP ANGLES'
      IF (ERROR.EQ.27) WRITE(7,*) 'BCK START IS LARGER THAN DATA START'
      IF (ERROR.EQ.28) WRITE(7,*) 'BCK STEP IS DIFFERENT THAN DATA STEP'
      IF (ERROR.EQ.29) WRITE(7,*) 'BCK STOP IS SMALLER THAN DATA STOP'
      IF (ERROR.EQ.26) WRITE(7,*) 'ERROR IN READING DATA POINTS'
      RETURN
      END

      

